(** val xorb : bool -> bool -> bool **)

let xorb b1 b2 =
  if b1 then if b2 then false else true else b2

(** val fst : ('a1 * 'a2) -> 'a1 **)

let fst = function
| (x, y) -> x

(** val snd : ('a1 * 'a2) -> 'a2 **)

let snd = function
| (x, y) -> y

(** val plus : int -> int -> int **)

let rec plus = (+)

(** val mult : int -> int -> int **)

let rec mult = ( * )

(** val minus : int -> int -> int **)

let rec minus = fun n m -> Pervasives.max 0 (n-m)

(** val pow : int -> int -> int **)

let rec pow n m =
  (fun fO fS n -> if n=0 then fO () else fS (n-1))
    (fun _ -> Pervasives.succ
    0)
    (fun m0 ->
    mult n (pow n m0))
    m

(** val divmod : int -> int -> int -> int -> int * int **)

let rec divmod x y q u =
  (fun fO fS n -> if n=0 then fO () else fS (n-1))
    (fun _ -> (q,
    u))
    (fun x' ->
    (fun fO fS n -> if n=0 then fO () else fS (n-1))
      (fun _ ->
      divmod x' y (Pervasives.succ q) y)
      (fun u' ->
      divmod x' y q u')
      u)
    x

(** val div : int -> int -> int **)

let div x y =
  (fun fO fS n -> if n=0 then fO () else fS (n-1))
    (fun _ ->
    y)
    (fun y' ->
    fst (divmod x y' 0 y'))
    y

(** val modulo : int -> int -> int **)

let modulo x y =
  (fun fO fS n -> if n=0 then fO () else fS (n-1))
    (fun _ ->
    y)
    (fun y' ->
    minus y' (snd (divmod x y' 0 y')))
    y

type uint8 = { g0 : bool; g1 : bool; g2 : bool; g3 : bool; g4 : bool;
               g5 : bool; g6 : bool; g7 : bool }

(** val g0 : uint8 -> bool **)

let g0 x = x.g0

(** val g1 : uint8 -> bool **)

let g1 x = x.g1

(** val g2 : uint8 -> bool **)

let g2 x = x.g2

(** val g3 : uint8 -> bool **)

let g3 x = x.g3

(** val g4 : uint8 -> bool **)

let g4 x = x.g4

(** val g5 : uint8 -> bool **)

let g5 x = x.g5

(** val g6 : uint8 -> bool **)

let g6 x = x.g6

(** val g7 : uint8 -> bool **)

let g7 x = x.g7

(** val pow2 : int -> int **)

let pow2 n =
  pow (Pervasives.succ (Pervasives.succ 0)) n

(** val grade2 : int -> int -> bool **)

let grade2 n m =
  (fun fO fS n -> if n=0 then fO () else fS (n-1))
    (fun _ ->
    false)
    (fun n0 ->
    true)
    (modulo (div n (pow2 m)) (Pervasives.succ (Pervasives.succ 0)))

(** val uint8_of_nat : int -> uint8 **)

let uint8_of_nat n =
  { g0 = (grade2 n 0); g1 = (grade2 n (Pervasives.succ 0)); g2 =
    (grade2 n (Pervasives.succ (Pervasives.succ 0))); g3 =
    (grade2 n (Pervasives.succ (Pervasives.succ (Pervasives.succ 0)))); g4 =
    (grade2 n (Pervasives.succ (Pervasives.succ (Pervasives.succ
      (Pervasives.succ 0))))); g5 =
    (grade2 n (Pervasives.succ (Pervasives.succ (Pervasives.succ
      (Pervasives.succ (Pervasives.succ 0)))))); g6 =
    (grade2 n (Pervasives.succ (Pervasives.succ (Pervasives.succ
      (Pervasives.succ (Pervasives.succ (Pervasives.succ 0))))))); g7 =
    (grade2 n (Pervasives.succ (Pervasives.succ (Pervasives.succ
      (Pervasives.succ (Pervasives.succ (Pervasives.succ (Pervasives.succ
      0)))))))) }

(** val b2n : bool -> int **)

let b2n = function
| true -> Pervasives.succ 0
| false -> 0

(** val nat_of_uint8 : uint8 -> int **)

let nat_of_uint8 u =
  plus
    (plus
      (plus
        (plus
          (plus
            (plus
              (plus (b2n u.g0) (mult (b2n u.g1) (pow2 (Pervasives.succ 0))))
              (mult (b2n u.g2) (pow2 (Pervasives.succ (Pervasives.succ 0)))))
            (mult (b2n u.g3)
              (pow2 (Pervasives.succ (Pervasives.succ (Pervasives.succ 0))))))
          (mult (b2n u.g4)
            (pow2 (Pervasives.succ (Pervasives.succ (Pervasives.succ
              (Pervasives.succ 0)))))))
        (mult (b2n u.g5)
          (pow2 (Pervasives.succ (Pervasives.succ (Pervasives.succ
            (Pervasives.succ (Pervasives.succ 0))))))))
      (mult (b2n u.g6)
        (pow2 (Pervasives.succ (Pervasives.succ (Pervasives.succ
          (Pervasives.succ (Pervasives.succ (Pervasives.succ 0)))))))))
    (mult (b2n u.g7)
      (pow2 (Pervasives.succ (Pervasives.succ (Pervasives.succ
        (Pervasives.succ (Pervasives.succ (Pervasives.succ (Pervasives.succ
        0)))))))))

(** val addb : bool -> bool -> bool -> bool **)

let addb a b c =
  xorb (xorb a b) c

(** val carry : bool -> bool -> bool -> bool **)

let carry a b c =
  (||) ((&&) a b) ((||) ((&&) a c) ((&&) b c))

(** val add_uint8 : uint8 -> uint8 -> uint8 **)

let add_uint8 u1 u2 =
  let c1 = (&&) u1.g0 u2.g0 in
  let c2 = carry u1.g1 u2.g1 c1 in
  let c3 = carry u1.g2 u2.g2 c2 in
  let c4 = carry u1.g3 u2.g3 c3 in
  let c5 = carry u1.g4 u2.g4 c4 in
  let c6 = carry u1.g5 u2.g5 c5 in
  let c7 = carry u1.g6 u2.g6 c6 in
  { g0 = (xorb u1.g0 u2.g0); g1 = (addb u1.g1 u2.g1 c1); g2 =
  (addb u1.g2 u2.g2 c2); g3 = (addb u1.g3 u2.g3 c3); g4 =
  (addb u1.g4 u2.g4 c4); g5 = (addb u1.g5 u2.g5 c5); g6 =
  (addb u1.g6 u2.g6 c6); g7 = (addb u1.g7 u2.g7 c7) }

