
let euc2_add (x1,y1) (x2,y2) = (x1 +. y1, x2 +. y2)
let euc2_mul c (x, y) = (c *. x, c *. y)

let ( +& ) (x1,y1) (x2,y2) = euc2_add (x1,y1) (x2, y2)
let ( *< ) c (x,y) = euc2_mul c (x,y)

let euc2_inner_product (x1, y1) (x2, y2) = x1 *. x2 +. y1 *. y2
let euc2_norm (x, y) = sqrt (euc2_inner_product (x,y) (x,y))
let euc2_arg (x1, y1) (x2, y2) = acos (euc2_inner_product (x1,y1) (x2, y2) /. (euc2_norm (x1,y1) *. euc2_norm (x2,y2)))

let motion (x_pre, y_pre) (vx_pre, vy_pre) dt =
  (x_pre, y_pre) +& (dt *< (vx_pre, vy_pre))

let euler_so2 (x_pre, y_pre) (vx_pre, vy_pre) dt =
  let (x, y) = (x_pre, y_pre) +& (dt *< (vx_pre, vy_pre)) in
  let (vx, vy) = (vx_pre, vy_pre) +& (dt *< ((-1.) *< (x_pre, y_pre))) in
  ((x, y), (vx, vy))
