
let timer = ref 0
let angle () =
  if 0 <= !timer && !timer < 72000 then (float !timer) *. 0.05
  else 0.


let () =
  ignore (Glut.init Sys.argv);
  Glut.initDisplayMode ~double_buffer:true ();
  Glut.initWindowSize ~w:512 ~h:512;
  ignore (Glut.createWindow ~title:"LablGL Demo");
  GlClear.color (0., 0., 0.);
  GlDraw.shade_model `smooth;
  let render () =
    GlMat.mode `projection;
    GlMat.load_identity ();
    GluMat.ortho2d ~x:(-5., 5.) ~y:(-5., 5.);
    GlMat.mode `modelview;
    GlMat.load_identity ();
    GlClear.clear [ `color ];
    GlMat.rotate ~angle:(angle ()) ~z:1. ();
    GlDraw.color (0.8,0.8,0.8);
    GlDraw.begins `quads;
    List.iter GlDraw.vertex2 [-1., -1.; -1., 1.; 1., 1.; 1., -1.];
    GlDraw.ends ();
    Gl.flush ();
    timer := if !timer < 72000 then !timer+1 else 0; 
    Glut.swapBuffers ()
  in
  Glut.displayFunc ~cb:render;
  Glut.idleFunc ~cb:(Some Glut.postRedisplay);
  Glut.keyboardFunc ~cb:(fun ~key ~x ~y -> if key=27 then exit 0);
  Glut.mainLoop ()
