
Definition add_v2 {F : Type} (add : F -> F -> F) (u v : F*F) : F*F :=
  ((add (fst u) (fst v)), (add (snd u) (snd v))).

Definition mul_v2 {F : Type} (mul : F -> F -> F) (c : F) (u : F*F) : F*F :=
  ((mul c (fst u)), (mul c (snd u))).

Lemma comm_add_v2 {F : Type} : forall (add : F -> F -> F) (u v : F*F),
                                 add (fst u) (fst v) = add (fst v) (fst u)
                                 -> add (snd u) (snd v) = add (snd v) (snd u)
                                 -> add_v2 add u v = add_v2 add v u.
Proof.
  intros.
  unfold add_v2.
  rewrite H.
  rewrite H0.
  reflexivity.
Qed.


Lemma ass_mul_v2 {F : Type} : forall (mul : F -> F -> F) (a b : F) (u : F*F),
                                mul (mul a b) (fst u) = mul a (mul b (fst u))
                                -> mul (mul a b) (snd u) = mul a (mul b (snd u))
                                -> mul_v2 mul (mul a b) u = mul_v2 mul a (mul_v2 mul b u).
Proof.
  intros mul a b u H1 H2.
  unfold mul_v2.
  simpl.
  rewrite H1.
  rewrite H2.
  reflexivity.
Qed.

Extraction "vec2dbase.ml" add_v2 mul_v2.