

let ( +& ) (u1,u2) (v1,v2) =
  match add_v2 ( +. ) (Pair (u1,u2)) (Pair (v1,v2)) with
  | Pair (w1, w2) -> (w1,w2)
      
let ( *< ) c (v1,v2) =
  match mul_v2 ( *. ) c (Pair (v1,v2)) with
  | Pair (w1, w2) -> (w1,w2)

let motion (x_pre, y_pre) (vx_pre, vy_pre) dt =
  (x_pre, y_pre) +& (dt *< (vx_pre, vy_pre))

let euler_so2 (x_pre, y_pre) (vx_pre, vy_pre) dt =
  let (x, y) = (x_pre, y_pre) +& (dt *< (vx_pre, vy_pre)) in
  let (vx, vy) = (vx_pre, vy_pre) +& ((-.dt) *< (x_pre, y_pre)) in
  ((x, y), (vx, vy))
